#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import asyncio
import datetime

# Print current time five times


async def display_date(loop):
    end_time = loop.time() + 5.0    # loop.time() returns current time, as a float value, according to the event loop’s internal clock
    while True:
        print(datetime.datetime.now())
        if (loop.time() + 1.0) >= end_time:
            break
        await asyncio.sleep(1)      # asyncio.sleep(time) creates a coroutine that completes after a given time (in seconds)


loop = asyncio.get_event_loop()
loop.run_until_complete(asyncio.wait([display_date(loop), display_date(loop)]))
loop.close()
