#!/usr/bin/env python3
# -*- coding: utf-8 -*-


import asyncio
import os
import urllib.request


async def download(url):
    filename = os.path.basename(url)
    print(f'Starting downloading {filename}')

    request = urllib.request.urlopen(url)       # Synchronous download

    with open(filename, 'wb') as fout:
        while True:
            chunk = request.read(1024)
            if not chunk:
                break
            fout.write(chunk)

    print(f'Finished downloading {filename}')


async def main(urls):
    coroutines = [download(url) for url in urls]
    await asyncio.wait(coroutines)


urls = [f'https://d3s.mff.cuni.cz/files/teaching/nprg065/2019/python-lecture-0{x}.pdf' for x in range(1, 4)]

event_loop = asyncio.get_event_loop()
event_loop.run_until_complete(main(urls))
event_loop.close()
